#!/bin/sh
#
# This is a very simple script to report a quick statistic from the
# qmail-queue.log or qmail-queue.log.x.gz, it needs to be improved...
#
# You can send a mail with the output after rotating qmail-queue.log
#
# Salvatore Toribio
# 20060910
#

if [ ! $1  ]; then
   echo "
   Usage:  $0  <qmail-queue.log>

   It is possible to analize compress files i.e.: qmail-queue.log.1.gz

"
   exit 1
fi

if [ ! -f "$1" ]; then
   echo "
   File: '$1' doesn't exist, exit.
"
   exit
fi

FF="`file $1 | grep 'gzip compressed data'`"

echo

if [ ! "$FF" ]; then
   # It is not a compress file
   grep "here be a virus\|------ \| SA: yup, this smells \| q_s: Policy BLOCK" $1 \
   | grep -v " message for " \
   | sed -e "s/.* hits.* - message \(tagged\|quarantined\|deleted\|rejected\) .*$/Spam \1/" \
   | sed -e "s/^.* Process .*$/Messages processed/"  \
   | sed -e "s/^.* q_s: Policy BLOCK$/Policy blocked/"  \
   | sed -e "s/.*(\(.*\))$/Virus \1/" | sort | uniq -c | sort -gr
   echo
else
   # It is a compress file
   zcat $1 | grep "here be a virus\|------ \| SA: yup, this smells \| q_s: Policy BLOCK" \
   | grep -v " message for " \
   | sed -e "s/.* hits.* - message \(tagged\|quarantined\|deleted\|rejected\) .*$/Spam \1/" \
   | sed -e "s/^.* Process .*$/Messages processed/"  \
   | sed -e "s/^.* q_s: Policy BLOCK$/Policy blocked/"  \
   | sed -e "s/.*(\(.*\))$/Virus \1/" | sort | uniq -c | sort -gr
   echo
fi

echo
