sub clamscan_scanner {
  #ClamScan scanner
  &debug("clamscan: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);

  my ($start_clamscan_time)=[gettimeofday];
  my ($DD,$clamscan_status,$stop_clamscan_time,$clamscan_time);
  my ($clamscan_verbose,$eclamscan_status);
  $clamscan_verbose="-v" if ($DEBUG);

  &debug("run $clamscan_binary $clamscan_options  $ENV{'TMPDIR'} 2>&1",5);

  $DD=`$clamscan_binary $clamscan_options $ENV{'TMPDIR'} 2>&1`;
  $clamscan_status=$?;
  $eclamscan_status=($clamscan_status >> 8);

  &debug("--output of clamscan was:\n$DD--",5);

  if ( $eclamscan_status > 0 ) {
    if ($eclamscan_status == 1 && $DD =~ /\:\s(.*)\sFOUND$/m) {
      $quarantine_description=$+;
      &debug("clamscan: there be a virus! ($quarantine_description)",1);
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="CLAMSCAN:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---clamscan results ---\n$DD";
    } else {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("clamscan: corrupt or unknown ClamAV scanner error or memory/resource/perms problem - exit status $eclamscan_status");
    }
  } else {
    if ($DD =~ /Recursion limit exceeded/) {
      $quarantine_description="Resource attack - $1";
      &debug("clamscan: $quarantine_description",1);
      $quarantine_event="CLAMSCAN:Resource_attack";
      $description .= "\n---clamscan results ---\n$DD";
    } elsif ($clamscan_status > 0) {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("clamscan: corrupt or unknown ClamAV scanner error or memory/resource/perms problem - exit status $eclamscan_status");
    }
  }
  
  $stop_clamscan_time=[gettimeofday];
  $clamscan_time = tv_interval ($start_clamscan_time, $stop_clamscan_time);
  &debug("clamscan: finished scan in $clamscan_time secs",2);
}
