sub fpscan_scanner {
  #F-prot scanner version 6 (fpscan)
  &debug("fpscan: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);

  my ($start_fpscan_time)=[gettimeofday];
  my ($DD,$fpscan_status,$efpscan_status,$stop_fpscan_time,$fpscan_time,$fpscan_verbose);
  $fpscan_verbose="" if ($DEBUG);

  &debug("run $fpscan_binary --report --adware --applications  $ENV{'TMPDIR'}  2>&1",5);

  $DD=`$fpscan_binary --report --adware --applications  $ENV{'TMPDIR'} 2>&1`;
  $fpscan_status=$?;
  $efpscan_status=$fpscan_status>>8;

  &debug("--output of fpscan was:\n$DD--",5);

  if ( $efpscan_status > 0 ) {
    if ($efpscan_status & 1 || $efpscan_status & 2) {
      if ($DD =~ /^\[Found\s+[^\s]+\s+([^\s]+)/m) {
        $quarantine_description=$1;
      } else {
        $quarantine_description=$+;
      }
      $quarantine_description=~s/^\s+//g;
      $quarantine_description=~s/^\<//g;
      &debug("fpscan: there be a virus! ($quarantine_description)",1);
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="FPSCAN:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---fpscan results ---\n$DD";
    } elsif ($efpscan_status & 16) {
      #This implies a platform error (out of memory, real I/O errors, insufficient permissions, etc)
      &error_condition("fpscan: platform error (out of memory, real I/O errors, insufficient permissions, etc) - exit status $fpscan_status");
    } elsif ($efpscan_status & 32) {
      #This implies an internal engine error
      &error_condition("fpscan: enigine error - exit status $fpscan_status");
    } else {
      &error_condition("fpscan: unexpected exit code - exit status $fpscan_status/$efpscan_status");

      # fpscan exit code binary bits:
      #
      # bit 1 (1)   ==> At least one virus-infected object was found (and
      #                 remains).
      # bit 2 (2)   ==> At least one suspicious (heuristic match) object was
      #                 found (and remains).
      # bit 3 (4)   ==> Interrupted by user (SIGINT, SIGBREAK).
      # bit 4 (8)   ==> Scan restriction caused scan to skip files (maxdepth
      #                 directories, maxdepth archives, exclusion list, etc).
      # bit 5 (16)  ==> Platform error (out of memory, real I/O errors,
      #                 insufficient file permission etc.)
      # bit 6 (32)  ==> Internal engine error (whatever the engine fails at)
      # bit 7 (64)  ==> At least one object was not scanned (encrypted file,
      #                 unsupported/unknown compression method, corrupted or
      #                 invalid file).
      # bit 8 (128) ==> At least one object was disinfected (clean now).
    }
  }

  $stop_fpscan_time=[gettimeofday];
  $fpscan_time = tv_interval ($start_fpscan_time, $stop_fpscan_time);
  &debug("fpscan: finished scan in $fpscan_time secs",2);
}
