sub fsecure_scanner {
  #Fsecure scanner
  &debug("fsecure: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);
  my ($start_fsecure_time)=[gettimeofday];
  my ($DD,$fsecure_status,$efsecure_status,$stop_fsecure_time,$fsecure_time,$fsecure_verbose);
  $fsecure_verbose="--list" if ($DEBUG);

  &debug("run $fsecure_binary  $fsecure_verbose --archive --auto --dumb  $ENV{'TMPDIR'} 2>&1",5);
  $DD=`$fsecure_binary  $fsecure_verbose --archive --auto --dumb  $ENV{'TMPDIR'}  2>&1`;
  $fsecure_status=$?;
  $efsecure_status=($fsecure_status >> 8);

  &debug("--output of fsecure was:\n$DD--",5);
  if ( $efsecure_status !~ /^(0|9)$/ ) {
    if ($efsecure_status =~ /^(3|6|8)$/ ) {
      if ($DD =~ /(infection|infected|suspected):(.*)$/im) {
	$quarantine_description=$2;
	#Fsecure has some hair-brained descriptions we're better off without if possible
	if ($DD =~ /(infection|infected|suspected):(|\s+)([^\s]+)\s\[AVP/im) {
	  $quarantine_description=$3;
	} elsif ($DD =~ /(infection|infected|suspected):(|\s+)([^\s]+)\s\[/im) {
	  $quarantine_description=$3;
	}
	$quarantine_description=~s/^\s+//g;
	&debug("fsecure: there be a virus! ($quarantine_description)",1);
	($quarantine_event=$quarantine_description)=~s/\s/_/g;
	$quarantine_event="FSEC:".substr($quarantine_event,0,$QE_LEN);
	$description .= "\n---fsecure results ---\n$DD";
      } else {
	&error_condition("Fsecure scanner claims virus found - but I can't find it! - exit status $fsecure_status/$efsecure_status");
      }
    } else {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("corrupt or unknown Fsecure scanner error or memory/resource/perms problem - exit status $fsecure_status/$efsecure_status");
    }
  } elsif ($efsecure_status == 0 && $fsecure_status > 0) {
    #This implies a corrupt set of DAT files or resource problems...
    &error_condition("corrupt or unknown Fsecure scanner error or memory/resource/perms problem - exit status $fsecure_status/$efsecure_status");
  }
  $stop_fsecure_time=[gettimeofday];
  $fsecure_time = tv_interval ($start_fsecure_time, $stop_fsecure_time);
  &debug("fsecure: finished scan in $fsecure_time secs",2);
}
