sub hbedv_scanner {
  #H+BEDV scanner
  &debug("hbedv: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);
  my ($start_hbedv_time)=[gettimeofday];
  my ($DD,$hbedv_status,$ehbedv_status,$stop_hbedv_time,$hbedv_time,$hbedv_verbose);
  $hbedv_verbose="-v" if ($DEBUG);

  &debug("run $hbedv_binary  $hbedv_options $hbedv_verbose $ENV{'TMPDIR'}  2>&1",5);
  $DD=`$hbedv_binary $hbedv_options $hbedv_verbose -s $ENV{'TMPDIR'}   2>&1`;
  $DD=~s/\r//g;
  $hbedv_status=$?;
  $ehbedv_status=($hbedv_status >> 8);

  &debug("--output of hbedv was:\n$DD--",5);
  if ( $ehbedv_status != 0  ) {
    if ($DD =~ /^\s+ALERT:\s+\[([^\]]+)/m || $DD =~ /(VIRUS.*)$/m) {
      $quarantine_description=$1;
      &debug("hbedv: there be a virus! ($quarantine_description)",1);
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="HBEDV:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---hbedv results ---\n$DD";
    } elsif ($ehbedv_status == 214) {
      #This means you're running the demo-mode scanner and it didn't
      #find a virus
    } else {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("corrupt or unknown H+BEDV scanner error or memory/resource/perms problem - exit status $hbedv_status/$ehbedv_status");
    }
  } elsif ($hbedv_status > 0) {
    #This implies a corrupt set of DAT files or resource problems...
    &error_condition("corrupt or unknown H+BEDV scanner error or memory/resource/perms problem - exit status $hbedv_status/$ehbedv_status");
  }
  $stop_hbedv_time=[gettimeofday];
  $hbedv_time = tv_interval ($start_hbedv_time, $stop_hbedv_time);
  &debug("hbedv: finished scan in $hbedv_time secs",2);
}

