sub inocucmd_scanner {
  #Innoculan scanner
  &debug("inocucmd: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);
  my ($start_inocucmd_time)=[gettimeofday];
  my ($DD,$inocucmd_status,$einocucmd_status,$stop_inocucmd_time,$inocucmd_time);

  &debug("run $inocucmd_binary -SEC -NEX $ENV{'TMPDIR'}   2>&1",5);
  $DD=`$inocucmd_binary  -SEC -NEX $ENV{'TMPDIR'}  2>&1`;
  $inocucmd_status=$?;
  $einocucmd_status=($inocucmd_status >> 8);

  &debug("--output of inocucmd was:\n$DD--",5);
  
  if ( $einocucmd_status == 100 && $DD =~ /.*infected\sby\svirus\s(.*)\s/m  ) {
    $quarantine_description=$1;
    &debug("inocucmd: there be a virus! ($quarantine_description)",1);
    ($quarantine_event=$quarantine_description)=~s/\s/_/g;
    $quarantine_event="INOC:".substr($quarantine_event,0,$QE_LEN);
    $description .= "\n$DD\n";
  } elsif ( $einocucmd_status > 0 || ($einocucmd_status == 0 && $inocucmd_status > 0)) {
    #This implies a corrupt set of DAT files or resource problems...
    &error_condition("corrupt or unknown Innoculan scanner error or memory/resource/perms problem - exit status $inocucmd_status/$einocucmd_status");
  }
  
  $stop_inocucmd_time=[gettimeofday];
  $inocucmd_time = tv_interval ($start_inocucmd_time, $stop_inocucmd_time);
  &debug("inocucmd: finished scan in $inocucmd_time secs",2);
} 


