#ESET NOD32 scanner module for qmail-scanner 1.22
#by Maciej Soltysiak <solt@dns.toxicfilms.tv>
#Updated 9/Mar/06 by  mk@cm4all.com
# st: updated for version 2.70.x, thanks to Apro Krisztian 'apro - rndsoft.hu'
sub nod32_scanner {
  #ESET NOD32 scanner
  &debug("nod32: starting scan of directory \"$ENV{'TMPDIR'}\"...",5);
  my ($start_nod32_time)=[gettimeofday];
  my ($DD,$nod32_status,$stop_nod32_time,$nod32_time,$nod32_verbose);
  
  $DD=`$nod32_binary --subdir $ENV{'TMPDIR'}    2>&1`;
  $nod32_status=($? >> 8);
  &debug("--output of nod32 was:\n$DD--",5);
  if ( $nod32_status =~ /^(1|2)$/ && $DD =~ /virus="(.*?)"$/m) {
      $quarantine_description=$1;
      &debug("nod32: there be a virus! ($quarantine_description)",1);
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="nod32:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---nod32 results ---\n$DD";
      #	   print "virus \"$virus\"\n";
  } elsif ( $nod32_status !~ /^(0|3)$/ ) {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("corrupt or unknown Nod32 scanner error or memory/resource/perms problem - exit status $nod32_status");
  }
  $stop_nod32_time=[gettimeofday];
  $nod32_time = tv_interval ($start_nod32_time, $stop_nod32_time);
  &debug("nod32: finished scan in $nod32_time secs",2);
}
