sub normalize_string {
  my($type,$raw_string)=@_;
  my($bit,$string,$nstring,$encoding,$start_normalize_time,$stop_normalize_time,$normalize_time)='';
  $start_normalize_time=[gettimeofday];
  $string=$raw_string;
  if ($raw_string =~ /^\=\?[^\?]+\?([bq])\?(.*)\?\=$/i) {
    $encoding=$1;
    $string=$2;
    #&debug("normalize_string: $type \"$string\" is an \"$encoding\" encoded - normalize",4);
    if ($encoding =~ /^B$/i) {
      use MIME::Base64;
      foreach $bit (split(/=\?[^\?]+\?B\?/i,$raw_string)) {
        $bit=~s/\?=$//;
        $nstring .= decode_base64($bit);
      }
      &debug("normalize_string: $type \"$string\" is decoded to \"$nstring\"",4);
    }elsif ($encoding =~ /^Q$/i) {
      use MIME::QuotedPrint;
      foreach $bit (split(/=\?[^\?]+\?Q\?/i,$raw_string)) {
        $bit=~s/\?=$//;
        $nstring .= decode_qp($bit);
      }
      &debug("normalize_string: $type \"$string\" is decoded to \"$nstring\"",4);
    }else {
      &debug("normalize_string: encoded string discovered that isn't Quoted-printable or Base64",4);
      $illegal_mime=1;
      $destring='LOCALE_destring_problem';
      $quarantine_description="Disallowed MIME encoding - potential virus";
      $quarantine_event="Policy:Bogus_Encoding";
      $description .= "\n---perlscanner results ---\n$destring '$quarantine_description' found";
      #$file_desc .= "$file:$msg_size\t" if ($file_desc !~ /\Q$file\E/);
      return $string;
    }
  }else{
    $nstring=$string;
  }
  $stop_normalize_time=[gettimeofday];
  $normalize_time = tv_interval ($start_normalize_time, $stop_normalize_time);
  &debug("normalize_string: finished normalizing in $normalize_time secs",4) if ($encoding ne "");
  return $nstring;
}
